package org.ow2.odis.admin;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import org.objectweb.util.monolog.Monolog;
import org.objectweb.util.monolog.api.BasicLevel;
import org.objectweb.util.monolog.api.Logger;
import org.ow2.odis.domain.Domain;
import org.ow2.odis.engine.FWEvent;
import org.ow2.odis.engine.IProceed;

/**
 * The Class Admin.
 * @author Beyler Olivier FranceTelecom R&D
 */
public class Admin implements IProceed {
    /** Constant. */
    static final String GET_XML_INFO = "GET XML";

    /** Constant. */
    static final String ADD_XML = "ADD XML";

    /** Constant. */
    static final String GET_FULL_XML_INFO = "GET FULL XML";

    /** logger of the class. */
    private static final Logger LOGGER = Monolog.initialize().getLogger(
            Admin.class.getName());

    /**
     * Close.
     * @see com.francetelecom.odis.component.engine.IProceed#close()
     */
    public void close() {
    }

    /**
     * return always true;.
     * @param value the value
     * @return boolean
     */
    public boolean init(String value) {
        return true;
    }

    /**
     * do nothing actually.
     * @param event FWEvent
     */
    public void notifyFWEvent(FWEvent event) {
    }

    /**
     * Proceed request from link.
     * @param obj Object
     * @return List
     */
    public List proceed(Object obj) {
        List result = new ArrayList();
        String request = (String) obj;
        Domain domain;
        if (request != null) {
            try {
                if (GET_XML_INFO.equals(request)) {
                    domain = Domain.getInstance();
                    result.add(domain.exportXML());
                }
                if (GET_FULL_XML_INFO.equals(request)) {
                    domain = Domain.getInstance();
                    result.add(domain.exportXML());
                }
                if (request.startsWith(ADD_XML)) {
                    final String xml = request.substring(ADD_XML.length());
                    domain = Domain.getInstance();
                    domain.initByString(xml);
                    StringBuffer buffer = new StringBuffer("OK");
                    result.add(buffer.toString());
                }
            } catch (IOException e) {
                LOGGER.log(BasicLevel.ERROR, "IOException", e);
            }
        }
        return result;
    }
}
