package org.ow2.odis.admin;
/**
 * ActionInterface. Describe the interface requiered to add a new option for of Odis launch.
 * @author Olivier Beyler - OrangeLabs
 */
public interface IAction {
    /** The Constant SEPARATOR. Used for presentation. */
    String SEPARATOR = "==================================================================";

    /** The Constant CONSOLE . */
    String CONSOLE = "DIRECT_OUTPUT";

    /**
     * Every actions will be invoked to parse the args. It can do several task.
     * @param index current position into the parameter's array
     * @param arg string array of the parameters
     * @return the new index
     */
    int actions(int index, String arg[]);

    /**
     * give the description of the action. This will be use by the Help command to give a summurize of all available action.
     * @return the action's description.
     */
    String getDescriptions();

    /**
     * After have parsed all parameters the postDeclare of each action is performed. every action will be
     */
    void postDeclare();
}
