package org.ow2.odis.admin;
/**
 * @author olivier beyler - orange -labs
 */
public interface IPlugin {
    /**
     * Give the description of the plugin.
     * @return String.
     */
    String getDescription();

    /**
     * Give the name of the plugin.
     * @return String.
     */
    String getName();

    /**
     * Action performed when the plugin is installed.
     */
    void bind();

    /**
     * Action performed when the plugin is uninstalled.
     */
    void unbind();
}
