package org.ow2.odis.admin;
/**
 * @author olivier beyler - orange-labs
 */
public interface PluginsRegistryMBean {
    /**
     * Gets the list plugins.
     * @return the list plugins
     */
    public String listOfPlugins();

    /**
     * Adds the plugin.
     * @param classe the classe
     * @return the identity of the plugin
     * @throws InstantiationException the instantiation exception
     */
    public int addPlugin(String classe) throws InstantiationException;

    /**
     * Removes the plugin.
     * @param identity the identity of the plugin
     * @return true, if successful
     */
    public boolean removePlugin(final int identity);

    /**
     *
     */
    public void removePlugins();

    /**
     * Gets the plugin description.
     * @param identity the identity of plugin
     * @return the plugin description
     */
    public String getPluginDescription(final int identity);

    /**
     * @param fileName
     */
    public void loadPlugin(String fileName);
}
