package org.ow2.odis.admin.options;

import java.net.URL;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.objectweb.util.monolog.Monolog;
import org.objectweb.util.monolog.api.BasicLevel;
import org.objectweb.util.monolog.api.Logger;
import org.ow2.odis.admin.IAction;
import org.ow2.odis.admin.Launch;
import org.ow2.odis.domain.Domain;

/**
 * The Class AddConfigFile.
 * @author Olivier Beyler - OrangeLabs
 */
public class AddConfigFile implements IAction {
    
    /** logger of this class. */
    private static final Logger LOGGER = Monolog.initialize().getLogger(
            AddConfigFile.class.getName());

    /** String Constant. */
    private static final String DESCRIPTIONS = "-add fileName : adds xml file \"fileName\" to the config.";

    /** List of file name. */
    List lsFileName = new ArrayList();

    /**
     * Actions.
     * @param index the index
     * @param arg the arg
     * @return int
     * @see IAction
     */
    public int actions(int index, String[] arg) {
        if ("-add".equals(arg[index])) {
            index++;
            lsFileName.add(arg[index]);
            index++;
        }
        return index;
    }

    /**
     * Gets the descriptions.
     * @return the descriptions
     * @see IAction
     */
    public String getDescriptions() {
        return DESCRIPTIONS;
    }

    /**
     * Post declare.
     * @see IAction
     */
    public void postDeclare() {
        Iterator itFilename = lsFileName.iterator();
        URL url;
        String filename;
        while (itFilename.hasNext()) {
            filename = (String) itFilename.next();
            if (LOGGER.isLoggable(BasicLevel.DEBUG)) {
                LOGGER.log(BasicLevel.DEBUG, "merging config file " + filename);
            }
            url = AddConfigFile.class.getResource("/" + filename);
            if (url == null) {
                LOGGER.log(BasicLevel.FATAL, "Unable to find resource /"
                        + filename);
                continue;
            }
            Domain.addConfigUrl(url, Launch.doc);
        }
    }
}
