
package org.ow2.odis.admin.options;

import org.objectweb.util.monolog.Monolog;
import org.objectweb.util.monolog.api.BasicLevel;
import org.objectweb.util.monolog.api.Logger;
import org.ow2.odis.admin.IAction;
import org.ow2.odis.admin.Launch;
import org.ow2.odis.domain.Domain;


/**
 * The Class NoStopOnError2.
 * @author olivier beyler - orange-labs
 */
public class NoStopOnError2 implements IAction {
    
    /** The Constant LOGGER. */
    private static final Logger LOGGER = Monolog.initialize()
            .getLogger(CONSOLE);

    /**
     * Actions.
     * @param index the index
     * @param arg the arg
     * @return the int
     * @see com.francetelecom.odis.component.admin.IAction#actions(int, java.lang.String[])
     */
    public int actions(int index, String[] arg) {
        if ("-noStopOnError".equals(arg[index])) {
            LOGGER.log(BasicLevel.INFO, "noStopOnError is active");
            index++;
            Domain.getInstance().attribute.setStopOnError(false);
            Launch.getInstance().stopOnError = false;
        }
        return index;
    }

    /**
     * Gets the descriptions.
     * @return the descriptions
     * @see com.francetelecom.odis.component.admin.IAction#getDescriptions()
     */
    public String getDescriptions() {
        return "-noStopOnError : configuration elements having errors are just ignored";
    }

    /**
     * Post declare.
     * @see com.francetelecom.odis.component.admin.IAction#postDeclare()
     */
    public void postDeclare() {
    }
}
