package org.ow2.odis.bufferIn;

import java.util.List;

import org.objectweb.util.monolog.Monolog;
import org.objectweb.util.monolog.api.BasicLevel;
import org.objectweb.util.monolog.api.Logger;
import org.ow2.odis.connection.context.Context;

/**
 * Implement a factory for object without persistence.
 * @author olivier beyler - orange-labs
 */
public class BufferListObjectFactory {
    /** The Constant LOGGER. */
    static final Logger LOGGER = Monolog.initialize().getLogger(
            BufferListObjectFactory.class.getName());

    /**
     * Constructor.
     */
    public BufferListObjectFactory() {
        super();
        if (LOGGER.isLoggable(BasicLevel.DEBUG)) {
            LOGGER.log(BasicLevel.DEBUG, "create a Synchronized ObjectFactory");
        }
    }

    /**
     * create a new synchronized object.
     * @param identity the identity
     * @param msg the msg
     * @param objects the objects
     * @param context the context
     * @return the synchronized Object created with the param
     */
    public BufferListObject getObject(final String identity, final byte[] msg,
            final List objects, final Context context) {
        return new BufferListObject(identity, msg, objects, context);
    }
}
