package org.ow2.odis.connection;

import org.objectweb.util.monolog.Monolog;
import org.objectweb.util.monolog.api.BasicLevel;
import org.objectweb.util.monolog.api.Logger;
import org.ow2.odis.connection.context.IContextualConnectionOut;
import org.ow2.odis.model.AbstractConnectionAttribute;

/**
 * @author olivier
 */
public abstract class AbstractConnectionfactory implements IConnectionFactory {
    /**
     *
     */
    protected static final Logger LOGGER = Monolog.initialize().getLogger(
            AbstractConnectionfactory.class.getName());

    /**
     * @return
     */
    protected abstract String getTypeName();

    public IConnectionIn newConnectionIn(AbstractConnectionAttribute attribut) {
        defaultError("doesn't provide incoming connections");
        return null;
    }

    public IConnectionOut newConnectionOut(AbstractConnectionAttribute attribut) {
        defaultError("doesn't provide output connections");
        return null;
    }

    public IContextualConnectionOut newContextualConnectionOut(
            AbstractConnectionAttribute attribut) {
        defaultError("doesn't provide contextual connections");
        return null;
    }

    private void defaultError(String err) {
        StringBuffer msg = new StringBuffer(getTypeName());
        msg.append(" ");
        msg.append(err);
        msg.append(" - check your config ");
        LOGGER.log(BasicLevel.FATAL, msg.toString());
    }
}
