package org.ow2.odis.connection;

import java.util.Observer;

import org.ow2.odis.connection.context.ContextMessage;
import org.ow2.odis.lifeCycle.connection.IConnectionLifeCycle;
import org.ow2.odis.port.PortIn;

/**
 * A class needs to implement this interface to be used as a link in for a node.
 * @author Beyler Olivier FranceTelecom R&D
 */
public interface IConnectionIn extends IConnectionLifeCycle, Observer {
    /**
     * At least this function have to return 1 (but can return more) if there is message into the link.
     * @return int value
     */
    int getPendingMessage();

    /**
     * acknowledgment of the message for a link.
     * @param v boolean
     */
    void ackMessage(boolean v);

    /**
     * Gets the context message.
     * @return the context message
     */
    ContextMessage getContextMessage();

    /**
     * reference on Port In. It will be notified that a new Message comes.
     * @param portIn PortIn Value
     * @return the connection In
     */
    IConnectionIn setPortIn(PortIn portIn);
}
