package org.ow2.odis.connection.context;
/**
 * The Class ContextMessage.
 */
public class ContextMessage {
    /** The message payload. */
    private byte[] payload;

    /** The context. */
    private Context context;

    /**
     * Instantiates a new context message.
     * @param message the message
     * @param context the context
     */
    public ContextMessage(byte[] message, Context context) {
        super();
        this.payload = message;
        this.context = context;
    }

    /**
     * Gets the message.
     * @return the message
     */
    public byte[] getPayload() {
        return payload;
    }

    /**
     * Gets the context.
     * @return the context
     */
    public Context getContext() {
        return context;
    }

    /**
     * Equals.
     * @param message the message
     * @return true, if successful
     */
    public boolean equals(ContextMessage message) {
        if (message != null) {
            if (this.getContext() != null) {
                return this.getContext().equals(message.getContext());
            } else {
                return (message.getContext() == null);
            }
        } else {
            return false;
        }
    }
}
