package org.ow2.odis.connection.socket;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

import org.ow2.odis.model.SocketConnectionAttribute;

/**
 * The aim of this interface is to define a protocol this protocol is able to
 * create byte array from a stream
 * 
 * @author Beyler Olivier FranceTelecom R&D
 */
public interface IProtocolIn {
    /**
     * read a message
     * 
     * @param stream
     *            input stream
     * @param output
     *            stream can be use to give some information (for example
     *            :acknolegment)
     * @throws java.io.IOException
     * @return a byte array representing the read message.
     */
    byte[] read(InputStream stream, OutputStream output) throws IOException;

    /**
     * inform that if the stream is still open.
     * 
     * @return true or false
     */
    boolean isStreamStillOpen();

    /**
     * setter.
     * 
     * @param attribut
     *            allow protocol to get some information about the socket.
     */
    void setSocketCnxAttribut(SocketConnectionAttribute attribut);
}
