package org.ow2.odis.connection.socket;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

import org.ow2.odis.model.SocketConnectionAttribute;

/**
 * The aim of this interface is to define a protocol. This protocol is able to put a byte array to a stream.
 * @author Beyler Olivier FranceTelecom R&D
 */
public interface IProtocolOut {
    /**
     * write a message, the input stream is set to allow protocol to receive some information (example: an acknowledgement)
     * @param stream input stream
     * @param output output stream
     * @param message byte arrayr witch need to be sended
     * @return true if succed false in other case
     * @throws IOException exception can occured during this write
     */
    boolean write(InputStream stream, OutputStream output, byte[] message)
            throws IOException;

    /**
     * inform that if the stream is still open.
     * @return true or false
     */
    boolean isStreamStillOpen();

    /**
     * setter.
     * @param attribute allow protocol to get some information about the socket.
     */
    void setSocketCnxAttribut(SocketConnectionAttribute attribute);
}
