package org.ow2.odis.decoder;

import java.util.List;

/**
 * Interface that should implement a decoder in Odis Framework. from A byte array an object list will be created by the decoder.
 * @author Beyler Olivier FranceTelecom R&D
 */
public interface IDecoder /* extends IDecoderService */{
    /**
     * Decode.
     * @param msg byte array
     * @return list of object extract from message
     */
    List decode(byte[] msg);

    /**
     * Gets the type.
     * @return type of object decoded by this class
     */
    String getType();
}
