package org.ow2.odis.decoder;

import java.util.ArrayList;
import java.util.List;

import org.objectweb.util.monolog.Monolog;
import org.objectweb.util.monolog.api.BasicLevel;
import org.objectweb.util.monolog.api.Logger;

/**
 * Basic implementation of Decoder (doesn't decode anything). It's always return an empty list. <img src="doc-files/NullDecoder-1.png"/>
 * @author Beyler Olivier FranceTelecom R&D
 * @version 1.0
 */
public class NullDecoder implements IDecoder {
    /**
     * logger of this class.
     */
    static final Logger LOGGER = Monolog.initialize().getLogger(
            NullDecoder.class.getName());

    /**
     * Instantiates a new null decoder.
     */
    public NullDecoder() {
        super();
        if (LOGGER.isLoggable(BasicLevel.DEBUG)) {
            LOGGER.log(BasicLevel.DEBUG, "create NullDecoder");
        }
    }

    /**
     * Decode.
     * @param msg the msg
     * @return the list
     * @see com.francetelecom.odis.component.decoder.IDecoder#decode(byte[])
     */
    public List decode(byte[] msg) {
        if (LOGGER.isLoggable(BasicLevel.DEBUG)) {
            LOGGER.log(BasicLevel.DEBUG, "decoding msg");
        }
        List result = new ArrayList();
        return result;
    }

    /**
     * Gets the type.
     * @return the type
     * @see com.francetelecom.odis.component.decoder.IDecoder#getType()
     */
    public String getType() {
        return Object.class.getName();
    }
}
