package org.ow2.odis.decoder;

import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.List;

import org.objectweb.util.monolog.Monolog;
import org.objectweb.util.monolog.api.BasicLevel;
import org.objectweb.util.monolog.api.Logger;
import org.ow2.odis.util.IntegerModif;

/**
 * @author olivier beyler - orange-labs
 */
public class StringDecoder implements IDecoder {
    /** logger of this class. */
    static final Logger LOGGER = Monolog.initialize().getLogger(
            StringDecoder.class.getName());

    /**
     *
     */
    public StringDecoder() {
        super();
        if (LOGGER.isLoggable(BasicLevel.DEBUG)) {
            LOGGER.log(BasicLevel.DEBUG, "create StringDecoder");
        }
    }

    public List decode(byte[] msg) {
        if (LOGGER.isLoggable(BasicLevel.DEBUG)) {
            LOGGER.log(BasicLevel.DEBUG, "decoding msg");
        }
        List result = new ArrayList();
        IntegerModif index = new IntegerModif(0);
        try {
            int i = 0;
            byte[] temp = new byte[msg.length];
            while (index.intValue() < msg.length) {
                temp[i] = msg[index.intValue()];
                if (temp[i] == '\0') {
                    String chaine = new String(temp, "ISO-8859-1").substring(0,
                            i);
                    System.out.println("read :" + chaine);
                    result.add(chaine);
                    i = -1;
                    temp = new byte[msg.length];
                }
                index.setValue(index.intValue() + 1);
                i++;
            }
        } catch (UnsupportedEncodingException e) {
            LOGGER.log(BasicLevel.ERROR, "encoding exception: "
                    + e.getMessage());
        }
        if (LOGGER.isLoggable(BasicLevel.DEBUG)) {
            LOGGER.log(BasicLevel.DEBUG, result.toString());
        }
        return (result);
    }

    public String getType() {
        return String.class.getName();
    }
}
