package org.ow2.odis.domain;

import java.io.IOException;

/**
 * JMX MBean interface for the domain.
 * @author Beyler Olivier FranceTelecom R&D
 */
public interface DomainMBean {
    /**
     * initialize a new configuration or add some node or connection to this domain.
     * @param config String
     */
    void initByString(String config);

    /**
     * get info about the current version
     * @return info
     */
    String getInfoVersion();

    /**
     * export a xml view of the odis component. The optional parameters are ommited.
     * @return String
     * @throws IOException if the stream is broken
     */
    String exportXML() throws IOException;

    /**
     * export a xml view of the odis component. The optional parameters are added.
     * @return String
     * @throws IOException if the stream is broken
     */
    String exportFullXML() throws IOException;

    /**
     * getter on domain's name.
     * @return String
     */
    String getName();

    /**
     * getter on domain's path
     * @return String
     */
    String getPath();
}
