package org.ow2.odis.encoder;

import org.objectweb.util.monolog.Monolog;
import org.objectweb.util.monolog.api.BasicLevel;
import org.objectweb.util.monolog.api.Logger;

/**
 * The null encoder is just design as a cap. It doesn't encode an object but always produces the same result.
 * @author Beyler Olivier FranceTelecom R&D
 */
public class NullEncoder implements IEncoder {
    /** logger of this class. */
    static final Logger LOGGER = Monolog.initialize().getLogger(
            NullEncoder.class.getName());

    /**
     * constructor.
     */
    public NullEncoder() {
        super();
        if (LOGGER.isLoggable(BasicLevel.DEBUG)) {
            LOGGER.log(BasicLevel.DEBUG, "create NullEncoder");
        }
    }

    /**
     * Encode.
     * @param object the object
     * @return the byte[]
     * @see com.francetelecom.odis.component.encoder.IEncoder#encode(java.lang.Object)
     */
    public byte[] encode(Object object) {
        if (LOGGER.isLoggable(BasicLevel.WARN)) {
        	LOGGER.log(BasicLevel.WARN, "encoding \"text\" string to a byte array just for debug purpose !!!");
        	LOGGER.log(BasicLevel.WARN, "YOU SOULDN't USE THIS ENCODER");
        }
        byte[] result = "test".getBytes();
        return (result);
    }

    /**
     * Gets the type.
     * @return the type
     * @see com.francetelecom.odis.component.encoder.IEncoder#getType()
     */
    public String getType() {
        return Object.class.getName();
    }
}
