package org.ow2.odis.encoder;

import org.objectweb.util.monolog.Monolog;
import org.objectweb.util.monolog.api.BasicLevel;
import org.objectweb.util.monolog.api.Logger;
import org.ow2.odis.util.CodingDecoding;

/**
 * @author olivier beyler - orange-labs
 */
public class StringEncoder implements IEncoder {
    /** Logger for this class. */
    static final Logger LOGGER = Monolog.initialize().getLogger(
            StringEncoder.class.getName());

    /** Default constructor. */
    public StringEncoder() {
        super();
        if (LOGGER.isLoggable(BasicLevel.DEBUG)) {
            LOGGER.log(BasicLevel.DEBUG, "create StringEncoder");
        }
    }

    public byte[] encode(Object object) {
        if (LOGGER.isLoggable(BasicLevel.DEBUG)) {
            LOGGER.log(BasicLevel.DEBUG, "encoding msg");
        }
        byte[] result = null;
        byte[][] temp = new byte[2][];
        try {
            temp[0] = ((String) object).getBytes("ISO-8859-1");
            temp[1] = new byte[1];
            temp[1][0] = '\0';
        } catch (Exception e) {
            LOGGER.log(BasicLevel.ERROR, "Unable to encode " + object);
        }
        result = CodingDecoding.getLinearByte(temp);
        return result;
    }

    public String getType() {
        return String.class.getName();
    }
}
