package org.ow2.odis.engine;
/**
 * FWevent notify business process of framework event.
 * @author Beyler Olivier FranceTelecom R&D
 */
public class FWEvent {
    /** The event. */
    private int event = 0;

    /** The argue. */
    private int argue = 0;

    /** The Constant NODE. */
    public static final int NODE = 5;

    /** The Constant ENGINE_OUT. */
    public static final int ENGINE_OUT = 10;

    /** The Constant ENGINE_PROCEED. */
    public static final int ENGINE_PROCEED = 20;

    /** The Constant ENGINE_IN. */
    public static final int ENGINE_IN = 20;

    /** The Constant BEFORE_PROCEED. */
    public static final int BEFORE_PROCEED = 10;

    /** The Constant AFTER_PROCEED. */
    public static final int AFTER_PROCEED = 20;

    /** The Constant SUSPEND. */
    public static final int SUSPEND = 30;

    /** The Constant RELAUNCH. */
    public static final int RELAUNCH = 40;

    /**
     * Instantiates a new FW event.
     * @param pEvent the event
     * @param pArgue the argue
     */
    FWEvent(int pEvent, int pArgue) {
        super();
        this.event = pEvent;
        this.argue = pArgue;
    }

    /**
     * Gets the event.
     * @return the event
     */
    public int getEvent() {
        return event;
    }

    /**
     * Gets the argue.
     * @return the argue
     */
    public int getArgue() {
        return argue;
    }

    public String toString() {
        StringBuffer buf = new StringBuffer(FWEvent.class.getName());
        buf.append(":").append(event).append(":").append(argue);
        return buf.toString();
    }
}
