package org.ow2.odis.engine;

import java.util.List;

/**
 * The Interface IProceed.
 */
public interface IProceed /* extends IProceedService */{
    /**
     * Proceed.
     * @param obj the object that the proceed will consumme
     * @return the list of object produce by the proceed
     */
    List proceed(Object obj);

    /**
     * Init.
     * @param value the value
     * @return true if succeed false in other case
     */
    boolean init(String value);

    /**
     * will be called when the node is stopped.
     */
    void close();

    /**
     * Inform the proceed with all framework event.
     * @param event : com.francetelecom.odis.component.engine.FWEvent
     */
    void notifyFWEvent(FWEvent event);
}
