package org.ow2.odis.exception;

import org.ow2.odis.bufferOut.BufferOut;

/**
 * This exception is raised when a buffer can't accept more data.
 * @author ojoh6423
 */
public class OdisBufferOverflowException extends OdisException {
    /** Serialization identity. */
    private static final long serialVersionUID = 1L;

    /** The id of the buffer that refused data. */
    private BufferOut buffer;

    /**
     * Constructor.
     * @param message
     * @param buffer
     */
    public OdisBufferOverflowException(String message, BufferOut buffer) {
        super(message);
        this.buffer = buffer;
    }

    /**
     * Getter.
     * @return
     */
    public BufferOut getBuffer() {
        return buffer;
    }
}
