package org.ow2.odis.exception;
/**
 * This exception is raised when no buffer is found to satisfy a request.
 * @author Beyler Olivier FranceTelecom R&D
 */
public class OdisNoBufferException extends OdisException {
    /** Serialization identity. */
    private static final long serialVersionUID = 1L;

    /**
     * Default constructor.
     */
    public OdisNoBufferException() {
    }

    /**
     * Constructor with a message.
     * @param message the message describing the error
     */
    public OdisNoBufferException(final String message) {
        super(message);
    }

    /**
     * Constructor with a cause.
     * @param cause the underlying cause of the error
     */
    public OdisNoBufferException(final Throwable cause) {
        super(cause);
    }

    /**
     * Full Constructor.
     * @param message the message describing the error
     * @param cause the underlying cause of the error
     */
    public OdisNoBufferException(final String message, final Throwable cause) {
        super(message, cause);
    }
}
