package org.ow2.odis.lifeCycle.connection;

import org.objectweb.util.monolog.api.BasicLevel;
import org.ow2.odis.exception.OdisConnectionException;

/**
 * <img src="doc-files/statechart_connexion.png"/>
 * @author Beyler Olivier FranceTelecom R&D
 */
public final class StateConnectionStarted extends AbstractConnectionState {
    /**
     * Instantiates a new state cnx started.
     */
    public StateConnectionStarted() {
        super();
        state = IConnectionLifeCycle.STATE_STARTED;
    }

    /**
     * define the next state aviable.
     * @param cnx the cnx
     * @param wantedState the wanted state
     * @throws OdisConnectionException the odis cnx exception
     */
    public void setLifeState(final IConnectionLifeCycle cnx, final AbstractConnectionState wantedState) throws OdisConnectionException {
        StringBuffer buff;
        if (LOGGER.isLoggable(BasicLevel.DEBUG)) {
            buff = new StringBuffer(cnx.getClass().getName());
            buff.append(" setState to ");
            buff.append(IConnectionLifeCycle.STATES_NAME[wantedState.getState()]);
            LOGGER.log(BasicLevel.DEBUG, buff.toString());
        }
        switch (wantedState.getState()) {
        case IConnectionLifeCycle.STATE_STARTED:
            // do nothing
            break;
        case IConnectionLifeCycle.STATE_STOPPED:
            cnx.stopComponent();
            cnx.setConnectionState(wantedState);
            break;
        default:
            invalidTraitement(cnx, wantedState);
        }
    }
}
