package org.ow2.odis.model;
/**
 * This interface allows an user to get or set informations on a composite connection by a JMX MBean.
 * @author ojoh6423
 */
public interface CompositeConnectionAttributeMBean extends AbstractAttributeMBean {
    /**
     * Gets the max size in objects.
     * @return connection's size limit in object
     */
    int getSizeObjectMax();

    /**
     * Gets the max size in bytes.
     * @return connection's size limit in bytes
     */
    int getSizeByteMax();

    /**
     * Gets the number of messages.
     * @return the number of objects currently in this composite
     */
    int getNumberMessage();

    /**
     * Gets the size in bytes.
     * @return the number of bytes currently in this composite
     */
    long getSizeByte();

    /**
     * Gets the state string.
     * @return state of composite : TBD
     */
    String getStateString();
}
