package org.ow2.odis.model;
/**
 * this interface allows an user to get or set informations on a memory by a JMX MBean.
 * @author Beyler Olivier FranceTelecom R&D
 */
public interface MemoryConnectionAttributeMBean extends AbstractAttributeMBean {
    /**
     * empty the memory.
     */
    void clean();

    /**
     * Gets the size object max.
     * @return memory size's limit in object
     */
    int getSizeObjectMax();

    /**
     * Sets the size object max.
     * @param sizeObjectMax memory size's limit in object
     */
    void setSizeObjectMax(int sizeObjectMax);

    /**
     * Gets the size byte max.
     * @return memory size's limit in byte
     */
    int getSizeByteMax();

    /**
     * Sets the size byte max.
     * @param sizeByteMax memory size's limit in byte
     */
    void setSizeByteMax(int sizeByteMax);

    /**
     * Gets the number message.
     * @return the number of object present into this memory
     */
    int getNumberMessage();

    /**
     * Gets the size byte.
     * @return the number of byte present into this memory
     */
    long getSizeByte();

    /**
     * Gets the state string.
     * @return state of memory can be READY or NOT to accept a new object
     */
    String getStateString();
}
