package org.ow2.odis.model.cmd;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Set;

/**
 * The Class Cmd.
 */
public final class Cmd {
    /** The Constant EOL. */
    static final String EOL = System.getProperty("line.separator");

    /** timeStamp of the Cmd creation. */
    private long time = -1;

    /** The id localization. */
    private int idLocalization = -1;

    /** id of the sender. */
    private String domaine = "";

    /** The id sender. */
    private String idSender;

    /** id of the receiver. */
    private String idReceiver;

    /** map of the parameters. */
    private int idCmd = -1;

    /** The cmd. */
    private int cmd = -1;

    /** The byte buffer. */
    private byte[] byteBuffer = null;

    /**
     * To string.
     * @return the string
     * @see java.lang.Object#toString()
     */
    public String toString() {
        StringBuffer buffer = new StringBuffer("time        :");
        buffer.append(time);
        buffer.append(EOL);
        buffer.append("id Localization   :");
        buffer.append(idLocalization);
        buffer.append(EOL);
        buffer.append("id Sender   :");
        buffer.append(idSender);
        buffer.append(EOL);
        buffer.append("id Receiver :");
        buffer.append(idReceiver);
        buffer.append(EOL);
        buffer.append("id cmd      :");
        buffer.append(idCmd);
        buffer.append(EOL);
        buffer.append("cmd         :");
        buffer.append(cmd);
        buffer.append(EOL);
        Set set = mapParams.keySet();
        Iterator it = set.iterator();
        String key;
        Object param;
        while (it.hasNext()) {
            key = it.next().toString();
            param = mapParams.get(key);
            if (param == null) {
                buffer.append("param       :");
                buffer.append(key);
                buffer.append(" <UNDEFINED>");
                buffer.append(EOL);
            } else {
                buffer.append("param       :");
                buffer.append(key);
                buffer.append(" ");
                buffer.append(param.toString());
                buffer.append(EOL);
            }
        }
        return buffer.toString();
    }

    /** The map params. */
    private Map mapParams;

    /**
     * Default cnstructor.
     */
    public Cmd() {
        super();
        time = System.currentTimeMillis();
        mapParams = new HashMap();
    }

    /**
     * Gets the id sender.
     * @return the id sender
     */
    public String getIdSender() {
        return idSender;
    }

    /**
     * Sets the id sender. *
     * @param idEmmiter the new id sender
     */
    public void setIdSender(String idEmmiter) {
        this.idSender = idEmmiter;
    }

    /**
     * Gets the id receiver.
     * @return the id receiver
     */
    public String getIdReceiver() {
        return idReceiver;
    }

    /**
     * Sets the id receiver. *
     * @param idReceiver the new id receiver
     */
    public void setIdReceiver(String idReceiver) {
        this.idReceiver = idReceiver;
    }

    /**
     * Gets the time.
     * @return the time
     */
    public long getTime() {
        return time;
    }

    /**
     * Gets the map params.
     * @return the map params
     */
    public Map getMapParams() {
        return mapParams;
    }

    /**
     * Sets the time. *
     * @param time the new time
     */
    public void setTime(long time) {
        this.time = time;
    }

    /**
     * Gets the cmd.
     * @return the cmd
     */
    public int getCmd() {
        return cmd;
    }

    /**
     * Sets the cmd. *
     * @param cmd the new cmd
     */
    public void setCmd(int cmd) {
        this.cmd = cmd;
    }

    /**
     * Gets the id cmd.
     * @return the id cmd
     */
    public int getIdCmd() {
        return idCmd;
    }

    /**
     * Sets the id cmd. *
     * @param idCmd the new id cmd
     */
    public void setIdCmd(int idCmd) {
        this.idCmd = idCmd;
    }

    /**
     * Gets the id localization.
     * @return the id localization
     */
    public int getIdLocalization() {
        return idLocalization;
    }

    /**
     * Sets the id localization. *
     * @param idLocalization the new id localization
     */
    public void setIdLocalization(int idLocalization) {
        this.idLocalization = idLocalization;
    }

    /**
     * Gets the byte buffer.
     * @return the byte buffer
     */
    public byte[] getByteBuffer() {
        return byteBuffer;
    }

    /**
     * Sets the byte buffer. *
     * @param byteBuffer the new byte buffer
     */
    public void setByteBuffer(byte[] byteBuffer) {
        this.byteBuffer = byteBuffer;
    }

    /**
     * Gets the domaine.
     * @return the domaine
     */
    public String getDomaine() {
        return domaine;
    }

    /**
     * Sets the domaine. *
     * @param domaine the new domaine
     */
    public void setDomaine(String domaine) {
        this.domaine = domaine;
    }
}
