package org.ow2.odis.node;
/**
 * JMX MBean interface of node Manager.
 * @author Beyler Olivier FranceTelecom R&D
 */
public interface NodeManagerMBean {
    /**
     * get the list of the node's name.
     * @return string array.
     */
    String[] getListNodes();

    /**
     * Stop each node. It doesn't apply directly on live cycle as it usually do.
     */
    void stopComponent();

    /**
     * Unload the nodeManager and reinitialize the singleton to null.
     */
    void unloadComponent();

    /**
     * initialize Nodes by a string
     * @param config String
     * @deprecated use Domain initByString
     */
    void initByString(String config);
}
