package org.ow2.odis.policy;
/**
 * Define the interface that an element need to implement to be managed by a policy (IPolicy).
 * @author Beyler Olivier FranceTelecom R&D
 */
public interface IPolicyElement {
    /** The PROPERT y_ PRIORITY. */
    String PROPERTY_PRIORITY = "priority";

    /** The PROPERTY ID. */
    String PROPERTY_ID = "id";

    /**
     * Gets the priority for this element.<br>
     * A policy may use policy values to select one among otherwise eligible policy elements.
     * @return the priority value.
     */
    int getPriority();

    /**
     * Gets the id of this element.
     * @return the id
     */
    String getId();

    /**
     * Gets the number of pending messages.<br>
     * A policy may use this value to select one among otherwise eligible policy elements.
     * @return the number of pending (available) messages or objects this object currently contains.
     */
    int getPendingMessage();
}
