package org.ow2.odis.util;

import java.io.File;
import java.io.FilenameFilter;

/**
 * use to filter file by their exension.
 * 
 * @author Beyler Olivier FranceTelecom R&D
 */
public class Filter implements FilenameFilter {
    /** extension of the file. */
    private final String extention;

    /**
     * Constructor.
     * 
     * @param pExtension
     *            String
     */
    public Filter(String pExtension) {
	super();
	this.extention = pExtension;
    }

    /**
     * Accept.
     * 
     * @param dir
     *            the dir
     * @param name
     *            the name
     * @return true, if accept
     * @see java.io.FilenameFilter#accept(java.io.File, java.lang.String)
     */
    public boolean accept(File dir, String name) {
	return name.endsWith(extention);
    }
}
