package org.ow2.odis.util;

import java.io.EOFException;
import java.io.IOException;
import java.io.InputStream;

/**
 * This class is an utility class. It provide the read fully buffer from a stream.
 * @author Beyler Olivier FranceTelecom R&D
 */
public class StreamReader {
    /**
     * Read from stream until the lenght is reached.
     * @param input input stream
     * @param length size of byte buffer that the read must have filled
     * @return buffer fully read
     * @throws IOException occure if the stram is broken.
     */
    public byte[] read(final InputStream input, final int length)
            throws IOException {
        byte[] buf = new byte[length];
        int nbByteRead = -1;
        int count = 0;
        if (length != 0) {
            // utilise le caractere bloquant du read() pour attendre la presence
            // de byte dans le stream.
            final int c = input.read();
            if (c < 0) {
                throw new EOFException();
            }
            buf[0] = (byte) c;
            count++;
            do {
                nbByteRead = input.read(buf, count, length - count);
                if (nbByteRead < 0) {
                    throw new EOFException();
                }
                count += nbByteRead;
            } while (count != length);
        }
        return buf;
    }
}
