package org.ow2.odis.util;

import java.util.Iterator;
import java.util.List;

import org.ow2.odis.model.Const;

/**
 * 
 * @author olivier Beyler - OrangeLabs
 */
public class TraceException {

    /**
     * Format the list of exception or error witch have been occured.
     * @param list can contain Exception or String 
     * @return formated string List
     */
    public static String formatListException(List list) {
        StringBuffer result = new StringBuffer(Const.EOL);
        if (list == null || list.isEmpty()) {
            result.append("No Exception");
        } else {
            result.append("List of occured Exception(s) :");
            result.append(Const.EOL);
            Iterator it = list.iterator();
            Exception e;
            while (it.hasNext()) {
                Object ob = it.next();
                if (ob instanceof Exception) {
                    e = (Exception) ob;
                    result.append("   [");
                    result.append(e.getClass().getSimpleName());
                    result.append("] ");
                    if (e.getMessage() != null) {
                        result.append(e.getMessage());
                    }
                } else {
                    result.append(ob.toString());
                }

                result.append(Const.EOL);
            }
        }
        return result.toString();

    }
}
